#!/bin/bash

########################################################################
# Copyright (C) 2007-2009 Daniel Balsiger <mail<at>danielbalsiger.ch>  #
#                                                                      #
# This project evolved while my information science project and my     #
# master thesis that followed on.                                      #
#                                                                      #
# Check for latest versions at:                                        #
# https://danielbalsiger.ch/svn/repos/trunk/image-builder              #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License version 2 as    #
# published by the Free Software Foundation.                           #
#                                                                      #
########################################################################

##################################################
. ${BUILDDIR}/buildscripts/functions

VERSION="2.6.26.8"
SHA1SUM="bb51d5030b007b92b803d62716b22c28e1282fe4"
# this is 2.6.26.5 SHA1SUM="037c3ac83ba4da1ad4da91c0e485f97821767c2e"
# this is 2.6.26.3 SHA1SUM="34cd61891133c48236f683f8bd919a880c14e6c1"
URL="http://www.eu.kernel.org/pub/linux/kernel/v2.6"
FALLBACK="http://www.iam.unibe.ch/~rvs/research/adam/fallback"
BUILD_DEPS="toolchain"
##################################################

download_bz2 linux &&

cd ${BUILDDIR} &&
rm -rf linux* &&

cd ${BUILDDIR} &&
tar -xjvf ${SRCDIR}/linux-${VERSION}.tar.bz2 &&
mv linux-${VERSION} linux-${VERSION}-${BOARDNAME} &&
ln -s linux-${VERSION}-${BOARDNAME} linux &&
cd linux-${VERSION}-${BOARDNAME} &&

patch_src linux &&

make distclean &&
make ARCH=${BOARDARCH} CROSS_COMPILE=${CROSS_TARGET}- mrproper &&

cp ${BUILDCONFDIR}/config-linux .config &&
> ${BUILDDIR}/initramfs.cpio &&
rm -rf ${INSTALLDIR}/lib/modules -rf &&

make ARCH=${BOARDARCH} CROSS_COMPILE=${CROSS_TARGET}- oldconfig &&
make ARCH=${BOARDARCH} CROSS_COMPILE=${CROSS_TARGET}- vmlinux &&
make ARCH=${BOARDARCH} CROSS_COMPILE=${CROSS_TARGET}- modules &&
make ARCH=${BOARDARCH} CROSS_COMPILE=${CROSS_TARGET}- INSTALL_MOD_PATH=${INSTALLDIR} modules_install &&

${INSTALLDIR}/cross-tools/bin/depmod.pl -F System.map -b ${INSTALLDIR}/lib/modules/${VERSION}-${BOARDNAME}

