#!/bin/bash

########################################################################
# Copyright (C) 2007-2009 Daniel Balsiger <mail<at>danielbalsiger.ch>  #
#                                                                      #
# This project evolved while my information science project and my     #
# master thesis that followed on.                                      #
#                                                                      #
# Check for latest versions at:                                        #
# https://danielbalsiger.ch/svn/repos/trunk/image-builder              #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License version 2 as    #
# published by the Free Software Foundation.                           #
#                                                                      #
########################################################################

##################################################
. ${BUILDDIR}/buildscripts/functions

VERSION="3.4"
SHA1SUM="fcdf758d171211b72210d48b7303ccb5651a1850"
URL="http://www.kernel.org/pub/linux/utils/kernel/module-init-tools"
FALLBACK="http://www.iam.unibe.ch/~rvs/research/adam/fallback"
BUILD_DEPS="toolchain zlib"
##################################################

download_bz2 module-init-tools &&

cd ${BUILDDIR} &&
tar -xjvf ${SRCDIR}/module-init-tools-${VERSION}.tar.bz2 &&
cd module-init-tools-${VERSION} &&

patch_src module-init-tools &&

sed -e 's/-O2/-Os/g' -i configure &&
CC="${CC} -Os -fPIC" ./configure --host=${BOARDTARGET} --prefix=/ --enable-zlib --disable-largefile --disable-nls &&

make &&

make DESTDIR=${INSTALLDIR} install &&

mv -v ${INSTALLDIR}/sbin/{generate-modprobe.conf,rmmod,insmod,depmod} ${INSTALLDIR}/usr/sbin &&

cd ${BUILDDIR} &&
rm -rf module-init-tools-${VERSION}

