#!/bin/bash

########################################################################
# Copyright (C) 2007-2009 Daniel Balsiger <mail<at>danielbalsiger.ch>  #
#                                                                      #
# This project evolved while my information science project and my     #
# master thesis that followed on.                                      #
#                                                                      #
# Check for latest versions at:                                        #
# https://danielbalsiger.ch/svn/repos/trunk/image-builder              #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License version 2 as    #
# published by the Free Software Foundation.                           #
#                                                                      #
########################################################################

##################################################
. ${BUILDDIR}/buildscripts/functions

VERSION="0.9.8j"
SHA1SUM="f70f7127a26e951e8a0d854c0c9e6b4c24df78e4"
# This is 0.9.8i SHA1SUM="b2e029cfb68bf32eae997d60317a40945db5a65f" 
# This is 0.9.8h SHA1SUM="161a236909be07ad8d0a3aaadcd4c9f1c384a114"
URL="http://openssl.org/source"
FALLBACK="http://www.iam.unibe.ch/~rvs/research/adam/fallback"
BUILD_DEPS="toolchain zlib"
##################################################

download_gz openssl &&

cd ${BUILDDIR} &&
tar -xzvf ${SRCDIR}/openssl-${VERSION}.tar.gz &&
cd openssl-${VERSION} &&

patch_src openssl &&

./Configure linux-embedded-${BOARDARCH} --prefix=/ --openssldir=/etc/ssl no-idea no-md2 no-mdc2 no-rc2 no-rc5 no-sha0 no-smime no-rmd160 no-aes192 no-ripemd no-camellia no-ans1 no-krb5 no-ec no-err no-hw shared zlib-dynamic no-engines no-sse2 no-perlasm &&

make CC="${CC}" depend &&
make CC="${CC}" MANDIR=/usr/share/man &&
make CC="${CC}" MANDIR=/usr/share/man INSTALL_PREFIX="${INSTALLDIR}/" INSTALLTOP="/" install &&

mv -v ${INSTALLDIR}/lib/{libcrypto,libssl}.a ${INSTALLDIR}/usr/lib &&
cp -avf ${INSTALLDIR}/lib/engines ${INSTALLDIR}/usr/lib &&
rm -rf ${INSTALLDIR}/lib/engines &&
cp -av ${INSTALLDIR}/lib/pkgconfig ${INSTALLDIR}/usr/lib &&
rm -rf ${INSTALLDIR}/lib/pkgconfig &&
cp -av ${INSTALLDIR}/include/openssl ${INSTALLDIR}/usr/include &&
rm -rf ${INSTALLDIR}/include &&

cd ${BUILDDIR} &&
rm -rf openssl-${VERSION}

