#!/bin/bash

########################################################################
# Copyright (C) 2007-2009 Daniel Balsiger <mail<at>danielbalsiger.ch>  #
#                                                                      #
# This project evolved while my information science project and my     #
# master thesis that followed on.                                      #
#                                                                      #
# Check for latest versions at:                                        #
# https://danielbalsiger.ch/svn/repos/trunk/image-builder              #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License version 2 as    #
# published by the Free Software Foundation.                           #
#                                                                      #
########################################################################

##################################################
. ${BUILDDIR}/buildscripts/functions

VERSION="20080913"
SHA1SUM="f444aa082eb6dc397afcf461fedb1736f9a57bd3"
# This is 0.9.29 SHA1SUM="1c5a36dc2cfa58b41db413190e45675c44ca4691"
URL="http://uclibc.org/downloads/snapshots"
FALLBACK="http://www.iam.unibe.ch/~rvs/research/adam/fallback"
##################################################

export CC="${CROSS_TARGET}-gcc" &&
export CXX="${CROSS_TARGET}-g++" &&
export AR="${CROSS_TARGET}-ar" &&
export AS="${CROSS_TARGET}-as" &&
export LD="${CROSS_TARGET}-ld" &&
export RANLIB="${CROSS_TARGET}-ranlib" &&
export STRIP="${CROSS_TARGET}-strip" &&

download_bz2 uClibc &&

cd ${BUILDDIR} &&
tar -xjvf ${SRCDIR}/uClibc-${VERSION}.tar.bz2 &&
cd uClibc &&

patch_src uClibc &&

if [ "${BOARDARCH}" == "mips" ] ; then
    cp extra/Configs/Config.mips extra/Configs/Config.mips.orig &&
    sed -e "s:default CONFIG_MIPS_ISA_1:default CONFIG_MIPS_ISA_${MIPSLEVEL}:" extra/Configs/Config.mips.orig > extra/Configs/Config.mips
fi &&
cp Makefile{,.orig} &&
sed -e 's/$(LN) -fs/cp/g' Makefile.orig > Makefile &&
for file in `find libc/sysdeps/linux -name Makefile`; do
    cp $file{,.orig} &&
    sed -e 's/$(LN) -fs/cp/g' -e 's@../libc/@$(TOPDIR)libc/@g' $file.orig > $file
done &&
cp ${BUILDCONFDIR}/config-uClibc .config &&
cp .config{,.orig} &&
sed -e "/^CROSS_COMPILER_PREFIX/s:=.*:=\"${CROSS_TARGET}-\":" \
    -e "/^KERNEL_HEADERS/s:=.*:=\"${INSTALLDIR}/usr/include\":" \
    -e "/^SHARED_LIB_LOADER_PREFIX/s:=.*:=\"/lib\":" \
    -e "/^DEVEL_PREFIX/s:=.*:=\"/usr\":" \
    -e "/^RUNTIME_PREFIX/s:=.*:=\"/\":" \
    .config.orig > .config &&
make oldconfig &&
make CC="${CC}" &&
make PREFIX=${INSTALLDIR} install &&

cd ${BUILDDIR} &&
rm -rf uClibc &&

unset CC &&
unset CXX &&
unset AR &&
unset AS &&
unset LD &&
unset RANLIB &&
unset STRIP

