#!/bin/sh

########################################################################
# Copyright (C) 2007-2009 Daniel Balsiger <mail<at>danielbalsiger.ch>  #
#                                                                      #
# This project evolved while my information science project and my     #
# master thesis that followed on.                                      #
#                                                                      #
# Check for latest versions at:                                        #
# https://danielbalsiger.ch/svn/repos/trunk/image-builder              #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License version 2 as    #
# published by the Free Software Foundation.                           #
#                                                                      #
########################################################################

. /etc/init.d/rc.functions
. /etc/conf.d/rc.conf

update_meraki()
{
    image="$1"
    size=`du -k ${image} | awk '{ print $1 ; }'`
    if [ ${size} -gt 6144 ] ; then
        logecho "WARNING: Image is bigger, than the image partition..."
    else
        # first stop crond so no cfagent gets started again whhile I am sleeping
        /etc/init.d/rc.crond stop

        # sleep for 3 minutes, that my peers can get an updated image from me.
        sleep 180 
        
        # now our peers should have downloaded the update from me
        # I stop my httpd and cfservd services and do update myself
        /etc/init.d/rc.httpd stop
        /etc/init.d/rc.cfservd stop

        # calculate the image size for not wasting time by erasing all blocks
        let clearkb=6144-${size}
        let clearblocks=${clearkb}/64
        let clearblocks=${clearblocks}+1
        let imageblocks=96-${clearblocks}
 
        # do the update 
        (dd if=/dev/zero of=/dev/mtdblock1 bs=64k seek=${imageblocks} count=${clearblocks} 2>/dev/null \
            && dd if=${image} of=/dev/mtdblock1 bs=64k 2>/dev/null && logger -t cfengine  "Update ok, rebooting..." && /sbin/reboot ) \
            || ( logger -t cfengine "Update failed..." && /etc/init.d/rc.crond start && /etc/init.d/rc.httpd start )
    fi
}

if uname -a | grep meraki >/dev/null ; then
    if [ $# -ne 1 ] || [ -z $1 ] ; then
        echo "Usage: $0 <image>"
        exit 1
    fi
    if [ -f $1 ] ; then
        update_meraki $1
    fi
else
    logecho "Only supported on meraki platforms..."
    exit 1
fi

